Subject: RE: [hackers-il] Article: "The Most Important Software Innovation s" by David A. Wheeler

From: Chen Shapira <[email-masked]>
Date: Tue, 6 Aug 2002 17:08:09 +0200

> -----Original Message-----

> I read this article or at least scanned through it, and I can 
> tell that I
> was quite disappointed. Wheeler eliminated many important 
> innovations that
> seemed very critical to me, and a lot of minor, but important 
> innovations
> are missing.

While the list is far from complete, I thought it was pretty good. 

Some things bothered me though.
Do you consider refactoring an inovation? Its just a name for something we
were doing for years. If I wrote a good book about "Debugging", would this
be an innovation as well?

> Another factor that is not taken into effect, is integrating 
> innovations
> into larger innovations, or simply borrowing them and 
> encapsulating them
> while making them more usable. [1] Sure, Microsoft did invent too many
> things, and KDE and GNOME borrowed many concepts from Windows or
> Macintosh. (KDE can even emulate the three other systems) Does it make
> them bad?

We need to seperate "innovation" from "good implementation". Both are good
and important, but they are not the same thing. 
The first product that made good use of Reg-Exps is imporant, but it doesn't
belong in the innovation list. The idea of "reg-exps" is the innovation.

Of course, your definitions of "innovation" may vary (and it seems like they
do)

I remember reading in (IIRC) "Programming Pearls" that from the time binary
search was invented, it took several years until the first correct
implementation appeared.
Scary, isn't it?